> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.withpersona.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.withpersona.com/_mcp/server.

# Update an API key

PATCH https://api.withpersona.com/api/v1/api-keys/{api-key-id}
Content-Type: application/json

Updates an existing API key.

Reference: https://docs.withpersona.com/api-reference/api-keys/update-an-api-key

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `api-key-id` (string, required) — API key's ID (starts with "api_")

### Query parameters

- `include` (string, optional) — A comma-separated list of relationship paths. This can be used to customize which related resources will be fully serialized in the `included` key in the response. See [Serialization](https://docs.withpersona.com/serialization#inclusion-of-related-resources) for more details.
- `fields` (map from string to string, optional) — Comma-separated list(s) of attributes to include in the response. This can be used to customize which attributes will be serialized in the response. See [Serialization](https://docs.withpersona.com/serialization#sparse-fieldsets) for more details.

### Headers

- `Key-Inflection` (enum, optional) — Determines casing for the API response.
  - Allowed values: `camel`, `kebab`, `snake`
- `Idempotency-Key` (string, optional) — Ensures the request is idempotent.
- `Persona-Version` (enum, optional) — Server API version. More info on versioning can be found [here](https://docs.withpersona.com/versioning).
  - Allowed values: `2025-12-08`, `2025-10-27`, `2023-01-05`, `2022-09-01`, `2021-08-18`, `2021-07-05`, `2021-02-21`, `2020-05-18`

### Body (application/json)

This endpoint expects an object.

- `data` (ApiKeysApiKeyIdPatchRequestBodyContentApplicationJsonSchemaData, required)

## Response

### 200

This endpoint returns an API key object.

- `data` (api-key, required) — An API Key resource
- `included` (list of any, optional) — Excluded from the response by default. Will be an empty array when the `include` query parameter in the request was explicitly set to empty.

## Errors

### 400 Bad Request Error

The request was unacceptable, often due to invalid parameters.

- `errors` (list of ApiKeysApiKeyIdPatchResponsesContentApplicationJsonSchemaErrorsItems, optional)

### 401 Unauthorized Error

An invalid API key was provided.

- `errors` (list of ApiKeysApiKeyIdPatchResponsesContentApplicationJsonSchemaErrorsItems, optional)

### 403 Forbidden Error

The given API key doesn’t have permissions to perform the request or a quota has been exceeded.

- `errors` (list of ApiKeysApiKeyIdPatchResponsesContentApplicationJsonSchemaErrorsItems, optional)

### 404 Not Found Error

The requested resource doesn’t exist.

- `errors` (list of ApiKeysApiKeyIdPatchResponsesContentApplicationJsonSchemaErrorsItems, optional)

### 409 Conflict Error

The request conflicts with another request, often due to attempting to create a duplicate resource.

- `errors` (list of ApiKeysApiKeyIdPatchResponsesContentApplicationJsonSchemaErrorsItems, optional)

### 422 Unprocessable Entity Error

The request modifies the resource in an unacceptable way, often due to an invalid action or parameter.

- `errors` (list of ApiKeysApiKeyIdPatchResponsesContentApplicationJsonSchemaErrorsItems, optional)

### 429 Too Many Requests Error

Your organization’s rate limit has been exceeded. We recommend an exponential backoff on requests.

- `errors` (list of ApiKeysApiKeyIdPatchResponsesContentApplicationJsonSchemaErrorsItems, optional)

## Types

### ApiKeysApiKeyIdPatchRequestBodyContentApplicationJsonSchemaData

- `attributes` (ApiKeysApiKeyIdPatchRequestBodyContentApplicationJsonSchemaDataAttributes, required)

### api-key

An API Key resource

- `type` ("api-key", optional)
- `id` (string, optional)
- `attributes` (api-key-shared-attributes, optional)

### ApiKeysApiKeyIdPatchResponsesContentApplicationJsonSchemaErrorsItems

- `title` (string, optional)
- `details` (string, optional)

### ApiKeysApiKeyIdPatchRequestBodyContentApplicationJsonSchemaDataAttributes

- `name` (string, optional) — Human-readable name of the API key.
- `note` (string, optional) — Human readable context about the use of the API key.
- `api-version` (enum, optional) — API version that will be used for requests made with this API key. Defaults to the API version used when making this request.
  - Allowed values: `2025-12-08`, `2025-10-27`, `2023-01-05`, `2022-09-01`, `2021-08-18`, `2021-07-05`, `2021-02-21`, `2020-05-18`
- `api-key-inflection` (string, optional) — Default API response key inflection. Default is kebab-case.
- `api-attributes-blocklist` (list of string, optional) — Attributes blocked from API responses.
- `ip-address-allowlist` (list of string, optional) — IP addresses permitted for use by the API key.
- `permissions` (list of string, optional) — Abilities permitted to the API key.
- `file-access-token-expires-in` (integer, optional) — How soon any file access tokens returned in API responses expire. For more info see [Downloading Files](https://docs.withpersona.com/downloading-files).

### api-key-shared-attributes

- `name` (string, optional)
- `note` (string, optional, nullable)
- `api-version` (enum, optional) — Server API version. More info on versioning can be found [here](https://docs.withpersona.com/versioning).
  - Allowed values: `2025-12-08`, `2025-10-27`, `2023-01-05`, `2022-09-01`, `2021-08-18`, `2021-07-05`, `2021-02-21`, `2020-05-18`
- `api-key-inflection` (string, optional)
- `api-attributes-blocklist` (list of string, optional)
- `permissions` (list of string, optional)
- `ip-address-allowlist` (list of string, optional)
- `file-access-token-expires-in` (integer, optional)
- `last-used-at` (string, optional, nullable)
- `expires-at` (string, optional, nullable)
- `created-at` (datetime, optional)

## Examples

**Request**

```json
{
  "data": {
    "attributes": {
      "name": "Default API Key"
    }
  }
}
```

**Response**

```json
{
  "data": {
    "type": "api-key",
    "id": "api_ABC123",
    "attributes": {
      "name": "Default API Key",
      "note": null,
      "api-version": "2023-01-05",
      "api-key-inflection": "kebab",
      "api-attributes-blocklist": [
        "address-*",
        "name-last",
        "/data/attributes/fields/*-number"
      ],
      "permissions": [
        "account.read",
        "account.write",
        "api_log.read"
      ],
      "ip-address-allowlist": [
        "*"
      ],
      "file-access-token-expires-in": 21600,
      "last-used-at": "2023-08-17T23:24:00.000Z",
      "expires-at": null,
      "created-at": "2023-08-17T23:18:13.000Z"
    }
  }
}
```

**SDK Code**

```python Success
import requests

url = "https://api.withpersona.com/api/v1/api-keys/api-key-id"

payload = { "data": { "attributes": { "name": "Default API Key" } } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```javascript Success
const url = 'https://api.withpersona.com/api/v1/api-keys/api-key-id';
const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"attributes":{"name":"Default API Key"}}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Success
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.withpersona.com/api/v1/api-keys/api-key-id"

	payload := strings.NewReader("{\n  \"data\": {\n    \"attributes\": {\n      \"name\": \"Default API Key\"\n    }\n  }\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Success
require 'uri'
require 'net/http'

url = URI("https://api.withpersona.com/api/v1/api-keys/api-key-id")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"attributes\": {\n      \"name\": \"Default API Key\"\n    }\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java Success
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.withpersona.com/api/v1/api-keys/api-key-id")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"attributes\": {\n      \"name\": \"Default API Key\"\n    }\n  }\n}")
  .asString();
```

```php Success
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.withpersona.com/api/v1/api-keys/api-key-id', [
  'body' => '{
  "data": {
    "attributes": {
      "name": "Default API Key"
    }
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp Success
using RestSharp;

var client = new RestClient("https://api.withpersona.com/api/v1/api-keys/api-key-id");
var request = new RestRequest(Method.PATCH);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"attributes\": {\n      \"name\": \"Default API Key\"\n    }\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Success
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": ["attributes": ["name": "Default API Key"]]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.withpersona.com/api/v1/api-keys/api-key-id")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```